<?php
/*
 * Copyright (c) 2012, webvariants GbR, http://www.webvariants.de
 *
 * This file is released under the terms of the MIT license. You can find the
 * complete text in the attached LICENSE file or online at:
 *
 * http://www.opensource.org/licenses/mit-license.php
 */

abstract class WV2_RestrictArticletype_Helper {
	const METAINFO = 'restrict_articletypes';

	/**
	 * @param  sly_Model_Category $category
	 * @return array                         [typename,typename,...]
	 */
	public static function getAllowedTypes(sly_Model_Category $category) {
		$types = $category->getMeta(self::METAINFO, array());
		if (!empty($types)) return $types;

		// check parent
		$parent = $category->getParent($category->getClang());
		if ($parent) return self::getAllowedTypes($parent);

		// return list of all known types
		$service = sly_Service_Factory::getArticleTypeService();
		return array_keys($service->getArticleTypes());
	}
}
